# SPDX-License-Identifier: GPL-2.0
%YAML 1.2
---
$id: http://devicetree.org/schemas/mmc/allwinner,sun4i-a10-mmc.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Allwinner A10 MMC Controller Device Tree Bindings

allOf:
  - $ref: "mmc-controller.yaml"

maintainers:
  - Chen-Yu Tsai <wens@csie.org>
  - Maxime Ripard <mripard@kernel.org>

properties:
  "#address-cells": true
  "#size-cells": true

  compatible:
    oneOf:
      - const: allwinner,sun4i-a10-mmc
      - const: allwinner,sun5i-a13-mmc
      - const: allwinner,sun7i-a20-mmc
      - const: allwinner,sun8i-a83t-emmc
      - const: allwinner,sun9i-a80-mmc
      - const: allwinner,sun50i-a64-emmc
      - const: allwinner,sun50i-a64-mmc
      - items:
          - const: allwinner,sun8i-a83t-mmc
          - const: allwinner,sun7i-a20-mmc
      - items:
          - const: allwinner,sun8i-r40-emmc
          - const: allwinner,sun50i-a64-emmc
      - items:
          - const: allwinner,sun8i-r40-mmc
          - const: allwinner,sun50i-a64-mmc
      - items:
          - const: allwinner,sun50i-h5-emmc
          - const: allwinner,sun50i-a64-emmc
      - items:
          - const: allwinner,sun50i-h5-mmc
          - const: allwinner,sun50i-a64-mmc
      - items:
          - const: allwinner,sun50i-h6-emmc
          - const: allwinner,sun50i-a64-emmc
      - items:
          - const: allwinner,sun50i-h6-mmc
          - const: allwinner,sun50i-a64-mmc

  reg:
    maxItems: 1

  interrupts:
    maxItems: 1

  clocks:
    minItems: 2
    maxItems: 4
    items:
      - description: Bus Clock
      - description: Module Clock
      - description: Output Clock
      - description: Sample Clock

  clock-names:
    minItems: 2
    maxItems: 4
    items:
      - const: ahb
      - const: mmc
      - const: output
      - const: sample

  resets:
    maxItems: 1

  reset-names:
    const: ahb

required:
  - compatible
  - reg
  - interrupts
  - clocks
  - clock-names

unevaluatedProperties: false

examples:
  - |
    mmc0: mmc@1c0f000 {
        compatible = "allwinner,sun5i-a13-mmc";
        reg = <0x01c0f000 0x1000>;
        clocks = <&ahb_gates 8>, <&mmc0_clk>;
        clock-names = "ahb", "mmc";
        interrupts = <32>;
        bus-width = <4>;
        cd-gpios = <&pio 7 1 0>;
    };

...
